<?php
if ( !defined('ABSPATH') ) {
	exit; // Exit if accessed directly.
} 
if ( !class_exists('SWS_Store_Wide_Sale_Backend') ) {
	class SWS_Store_Wide_Sale_Backend {
		public function __construct() {
			add_action('admin_menu', array(__CLASS__, 'sws_register_menu_page'));
			add_action('admin_init', array(__CLASS__, 'sws_register_settings'));
			add_filter('woocommerce_screen_ids', array(__CLASS__, 'sws_screen_ids' ), 10, 1);
			add_action('admin_enqueue_scripts', array(__CLASS__, 'sws_enqueue_scripts') );
		}
		public static function sws_register_menu_page() {
			add_menu_page( esc_html__('Storewide Sale', 'storewide-sale'), esc_html__('Storewide Sale', 'storewide-sale'), 'manage_options', 'storewide-sale', array(__CLASS__, 'sws_settings_page'), 'dashicons-tag', 57);
		}
		public static function sws_register_settings() {
			register_setting( 'storewide_sale_general_settings', 'sws_storewide_sale_override' ); 
			register_setting( 'storewide_sale_general_settings', 'sws_storewide_sale_flash_override' );
			register_setting( 'storewide_sale_general_settings', 'sws_sale_flash_custom_html' );
			register_setting( 'storewide_sale_general_settings', 'sws_storewide_sale_timer');
			register_setting( 'storewide_sale_settings', 'sws_storewide_sale_enable' ); 
			register_setting( 'storewide_sale_settings', 'sws_storewide_sale_amount' );
			register_setting( 'storewide_sale_settings', 'sws_sale_amount_type' );
			register_setting( 'storewide_sale_settings', 'sws_sale_start_date' );
			register_setting( 'storewide_sale_settings', 'sws_sale_end_date' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_include_products' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_exclude_products' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_include_categories' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_exclude_categories' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_exclude_tags' );
			register_setting( 'storewide_sale_control_settings', 'sws_sale_exclude_tags' );
			register_setting( 'storewide_notification_settings', 'sws_storewide_notification_enable' );
			register_setting( 'storewide_notification_settings', 'sws_storewide_notification_text' );
			register_setting( 'storewide_notification_settings', 'sws_storewide_notification_position' );
			register_setting( 'storewide_notification_settings', 'sws_storewide_notification_bg' );
			register_setting( 'storewide_notification_settings', 'sws_storewide_notification_color' );
		}
		public static function sws_settings_page() {
			echo '<div class="wrap">';
				require_once WC_SWS_DIR . '/includes/class-sws-backend-settings.php';
			echo '</div>';
		}
		public static function sws_screen_ids( $screen_ids ) {
			$custom = array('toplevel_page_storewide-sale');
			$screen_ids = array_merge($custom, $screen_ids);
			return $screen_ids;
		}
		public static function sws_enqueue_scripts() {
			global $post_type;
			if ( ( isset($_GET['page']) && 'storewide-sale' == wc_clean($_GET['page']) ) || 'product' == $post_type ) {
				wp_enqueue_style( 'wp-color-picker' );
				wp_enqueue_script('jquery-ui-datepicker');    
				wp_enqueue_style( 'sws-backend', WC_SWS_URL . 'assets/css/backend_style.css', '', '1.0.6' );
				wp_enqueue_script( 'sws-backend', WC_SWS_URL . 'assets/js/backend_script.js', array('jquery', 'wp-color-picker'), '1.0.6' );
			}
		}
	}
	new SWS_Store_Wide_Sale_Backend();
}
